import { FormulaireElement } from "./formulaire-element";
import { ValueDependency } from "./dependency/value-dependency";
import { Dependency } from "./dependency/dependency";
import { isNumber } from "util";

export abstract class Field extends FormulaireElement {
    public abstract get isValid();

    public abstract getValue(): any;
    public abstract setValue(sender: any, val: any): void;

    private parse_value_dependencies(json: {}) {
        for (const di in json) {
            const d = json[di];
            const masterValue = d["refvalue"];
            const dep = new ValueDependency(this, d["refid"], masterValue);
            dep.slaveValue = d["value"];
            this._dependencies.push(dep);
        }
    }

    public parseDependencies(json: {}) {
        super.parseDependencies(json);

        const dep = json["dep_value"];
        if (dep !== undefined) {
            this.parse_value_dependencies(dep);
        }
    }

    /**
     * applique une dépendance dont la condition a été vérifiée
     */
    public applyDependency(d: Dependency) {
        if (d instanceof ValueDependency) {
            if (isNumber(d.slaveValue)) {
                this.setValue(this, +d.slaveValue);
            } else {
                this.setValue(this, d.slaveValue);
            }
        } else {
            super.applyDependency(d);
        }
    }
}
