import { ApplicationSetupService } from "./app-setup/app-setup.service";
import { ParamService } from "./param/param.service";
import { FormulaireService } from "./formulaire/formulaire.service";
import { I18nService } from "./internationalisation/internationalisation.service";
import { HttpService } from "./http/http.service";

export class ServiceFactory {
    private static _instance: ServiceFactory; // instance pour le pattern singleton

    private constructor() { }

    public applicationSetupService: ApplicationSetupService;

    public paramService: ParamService;

    public formulaireService: FormulaireService;

    public i18nService: I18nService;

    public httpService: HttpService;

    public static get instance() {
        if (ServiceFactory._instance === undefined) {
            ServiceFactory._instance = new ServiceFactory();
        }
        return ServiceFactory._instance;
    }
}
